/* $Header: /HBFontEdit/fontimport.c 15    15-11-96 18:25 Bert $ */
/* $Nokeywords: $ */

/************************************************************************/
/*       FontImport.c													*/
/*																		*/
/* Import routines voor Windows fonts									*/
/*																		*/
/* Copyright, (c) Bert Huijben, November 1996							*/
/************************************************************************/
#include <windows.h>

//#include "FontEdit.h"
//#include "FontVars.h"
//#include "FontHead.h"
#include "FontLoad.h"
#include "FontImport.h"

#include "FontCvt.h"	
////////

//CHOOSEFONT cf; // common dialog box structure
//LOGFONT lf;        // logical font structure
//int s_pch,s_avg,s_max,s_hgt;//,s_baseline;//,s_family, //s_charset;
//TEXTMETRIC tm;


/****************************************************************************
 * char * FontImport()
 *
 * purpose: reads in the specified font and creates a work bitmap for
 *          the editor. Also creates a local bitmap-offset table for easy
 *          access to the characters in the bitmap
 *
 * params : none
 *
 * returns: TRUE when OK
 *          (FALSE)
 *
 * side effects: lots
 *
 ****************************************************************************/
int FontImport(ImportFontType* Imp, FontType* lpFnt)
{
    CHAR  *lpFontBodySav = NULL;  /* local pointer to font body */
	UINT i;
    
    DWORD offset;	

	HFONT Fnt;
	HFONT hfontPrev;

	HDC hDC;
	COLORREF oldBkColor, oldTextColor;
	UINT oldAlign;
	int CharWidths[257];
	
	/* Put up an hourglass ... this may take a while */
    if (!hHourGlass)
        hHourGlass = LoadCursor(NULL, IDC_WAIT);        /* Get Hourglass */
    hOldCursor = SetCursor(hHourGlass);         /* Show hourglass */

	
    /* Ready to load -- Check if we will be overwriting */
    if (lpFnt->FontFormat != ID_NOFONT)
	{
        DeleteGlobalBitmap(lpFnt);
        //fLoaded = FALSE;
	}
	

	lpFnt->Header = Imp->Header;

    //iFontFormat = ID_FORMAT3;

    // Create a WINDOWS bitmap to move the font definition bits into

    hDC = GetDC (Imp->equalHWND);                       // DC to be compatible with

    Fnt = CreateFontIndirect(&Imp->lf);					// Character breedte ophalen.
	hfontPrev = SelectObject(hDC, Fnt);


	FillMemory(&CharWidths,sizeof(CharWidths),0);
	GetCharWidth(hDC, (UINT)lpFnt->Header.FirstChar, (UINT)lpFnt->Header.LastChar, (LPINT) &CharWidths);
	// Zou GetCharWidth32 moeten zijn, maar die geeft altijd een foutmelding Terug.        //HB:?????
	
	SelectObject(hDC, hfontPrev);
	// DeleteObject(Fnt);		// Bewaren, hebben we zo toch weer nodig.

	offset = 0;
    
	FillMemory(&lpFnt->offsets,sizeof(lpFnt->offsets),0);
	lpFnt->offsets[0] = 0;
	for (i = 0; i+lpFnt->Header.FirstChar <= 256 /*< (UINT)(lpFnt->LastChar - lpFnt->FirstChar + 1)*/; i++) 
	{
		lpFnt->offsets[lpFnt->Header.FirstChar+i+1] = offset += CharWidths[i];
	}
	
	//lpFnt->WidthBytes = (unsigned short)(offset >> 3);
	lpFnt->Header.WidthBytes = (WORD) (((offset + 15) >> 4) << 1);

    lpFnt->Bitmap = CreateBitmap(
                    (INT)lpFnt->Header.WidthBytes << 3, // Width of font in pixels
                    (INT)lpFnt->Header.PixHeight,
                    1, 1, (LPBYTE)NULL);
    lpFnt->BmDC = CreateCompatibleDC(hDC);				// Create a DC
    SelectObject(lpFnt->BmDC, lpFnt->Bitmap);			// Relate the two of them
    ReleaseDC(Imp->equalHWND, hDC);                     // Done with font DC
	
    hfontPrev = SelectObject(lpFnt->BmDC, Fnt);
	oldTextColor = SetTextColor(lpFnt->BmDC, 0xFFFFFF);
	oldBkColor = SetBkColor(lpFnt->BmDC, 0x000000);
	oldAlign = SetTextAlign(lpFnt->BmDC,TA_TOP);
	for(i = lpFnt->Header.FirstChar;i <= (UINT)(lpFnt->Header.LastChar); i++) 
	{
		char c = (CHAR)i;
		TextOut(lpFnt->BmDC, lpFnt->offsets[i],0,&c,1);
	}

	SetTextAlign(lpFnt->BmDC,oldAlign);
	SelectObject(lpFnt->BmDC,hfontPrev);
	
	SetTextColor(lpFnt->BmDC, oldTextColor);
	SetBkColor(lpFnt->BmDC, oldBkColor);

	//DeleteObject(hBrush);
	//SelectObject(hMemDC, hOldBrush);

	DeleteObject(Fnt);

	fConvStructInit();

    // Zet menu goed.
	lpFnt->FontFormat = ID_FORMAT2;
    //fLoaded = TRUE;
	//NewFile = TRUE;
	strcpy(lpFnt->szFaceName, Imp->szFaceName);
    lpFnt->CharCount = lpFnt->Header.LastChar - lpFnt->Header.FirstChar + 1;
    SetCursor(hOldCursor);              /* Restore regular cursor */
    return TRUE;
}


