/* $Header: /HBFontEdit/LdSvDlg.c 1     15-11-96 8:29 Bert $ */
/* $Nokeywords: $ */
/////////////////////////////////////////
// LdSvDlg.c
//
// Dialogen voor Load, Save en Import.
//
/////////////////////////////////////////

#include <windows.h>
#include <stdio.h>
#include "LdSvDlg.h"
#include "FontEdit.h"
#include "FontVars.h"
#include "FontHead.h"


void GetFontInfo(ImportFontType* ift)
{
	HFONT Fnt;
	HFONT hfontPrev;

	HDC hDC;
	
	hDC = GetDC (ift->equalHWND);					// DC to be compatible with
    Fnt = CreateFontIndirect(&ift->lf);
	hfontPrev = SelectObject(hDC, Fnt);

	GetTextMetrics(hDC,&(ift->tm));

	SelectObject(hDC, hfontPrev);
	DeleteObject(Fnt);
    ReleaseDC(ift->equalHWND, hDC);					// Done with font DC
}

ImportFontType ift;

int ImportFont(HWND equal)
{
	CHOOSEFONT cf;
	
	// Initialize CHOOSEFONT
	cf.lStructSize = sizeof (CHOOSEFONT);
	cf.hwndOwner = hBox;
	cf.lpLogFont = &ift.lf;
	cf.rgbColors = 0;
	cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_LIMITSIZE;
	cf.nSizeMax = 41;
	cf.nSizeMin = 4;
	ift.equalHWND = equal;

	if (ChooseFont(&cf)==TRUE)
	{
		ift.lf.lfQuality = PROOF_QUALITY;
		GetFontInfo(&ift);
		if(IDOK == DialogBox(hInst, (LPSTR)"CIMPORT", hBox, (FARPROC) &ImportProc) )
		{
			FontImport(&ift,&font);
			NewFile = TRUE;
			sprintf(szFontFile,"%s.FNT",ift.szFaceName);
			strcpy(szFontFileFull, szFontFile);
			strcpy(szNewFile, szFontFile);
			{
				HMENU hMenu;
				UINT mf;
				hMenu = GetMenu(hBox);  /* Gray menu if no clipboard bitmap */
				mf = (font.Header.Family & 1) ? MF_ENABLED : MF_GRAYED;
				EnableMenuItem(hMenu, FONT_SAVE, MF_ENABLED);
				EnableMenuItem(hMenu, FONT_SAVEAS, MF_ENABLED);
				EnableMenuItem(hMenu, 1, MF_BYPOSITION | MF_ENABLED);
				EnableMenuItem(hMenu, 2, MF_BYPOSITION | MF_ENABLED);
				EnableMenuItem(hMenu, 3, MF_BYPOSITION | mf);
				EnableMenuItem(hMenu, 4, MF_BYPOSITION | MF_ENABLED);
				EnableMenuItem(hMenu, 5, MF_BYPOSITION | MF_ENABLED);
				DrawMenuBar(hBox);
			}
		}
	};
	return 0;
};


BOOL newFixed;

BOOL  APIENTRY 
ImportProc(
	HWND   hDial,
	WORD   message,
	WPARAM wParam,
	LPARAM lParam
	)
{
	BOOL fOk;               /* for GetDlgItemInt errors! */
	UINT i;

	UNREFERENCED_PARAMETER(lParam);

    switch (message)
        {
    default:
        return FALSE;
    case WM_INITDIALOG:
        SetDlgItemText(hDial, IDC_COPYRIGHT, "HB Fonteditor");
		SetDlgItemText(hDial, IDC_FONTNAME, ift.lf.lfFaceName);

		SetDlgItemInt(hDial, IDC_MAX_LB,  ift.tm.tmMaxCharWidth, FALSE);
		SetDlgItemInt(hDial, IDC_AVG_LB,  ift.tm.tmAveCharWidth, FALSE);
		SetDlgItemInt(hDial, IDC_HEIGHT,  ift.tm.tmHeight, FALSE);
		SetDlgItemInt(hDial, IDC_BASELINE,ift.tm.tmAscent, FALSE);

		CheckDlgButton(hDial, ID_ITALIC, newItalic = ift.lf.lfItalic);
        CheckDlgButton(hDial, ID_UNDERLINE, newUnderline = ift.lf.lfUnderline);
        CheckDlgButton(hDial, ID_STRIKEOUT, newStrikeOut = ift.lf.lfStrikeOut);


		SetFixed(hDial, newFixed = (ift.tm.tmPitchAndFamily & TMPF_FIXED_PITCH));


        newCharSet = ift.lf.lfCharSet;
        SetCharSet(hDial);      /* Set OEM/ANSI buttons */

        newFamily = (WORD) (ift.lf.lfPitchAndFamily >> 4);   /* Working value */
        SetFamily(hDial);               /* Set Font Family */

		newWeight = (WORD) (ift.lf.lfWeight);   /* Working value */
        SetWeight(hDial);               /* Set Font Weight */


	    SetDlgItemInt(hDial, ID_FIRST_CHAR, ift.tm.tmFirstChar, FALSE);
        SetDlgItemInt(hDial, ID_LAST_CHAR, ift.tm.tmLastChar, FALSE);

		SetDlgItemInt(hDial, ID_POINTS, 100, FALSE);
        SetDlgItemInt(hDial, ID_VERT_RES,		ift.tm.tmDigitizedAspectY,	FALSE);
        SetDlgItemInt(hDial, ID_HORIZ_RES,		ift.tm.tmDigitizedAspectX,	FALSE);
        SetDlgItemInt(hDial, ID_EXT_LEADING,	ift.tm.tmExternalLeading,	FALSE);
        SetDlgItemInt(hDial, ID_INT_LEADING,	ift.tm.tmInternalLeading,	FALSE);
        SetDlgItemInt(hDial, ID_DEFAULT_CHAR,	ift.tm.tmDefaultChar ,		FALSE);
        SetDlgItemInt(hDial, ID_BREAK_CHAR,		ift.tm.tmBreakChar,			FALSE);

        break;
    case WM_COMMAND:
        switch (LOWORD(wParam))
            {
        case ID_ANSI:
            newCharSet = ANSI_CHARSET;
            SetCharSet(hDial);          /* Set OEM/ANSI buttons */
            break;
        case ID_SYMBOL:
            newCharSet = SYMBOL_CHARSET;
            SetCharSet(hDial);          /* Set OEM/ANSI buttons */
            break;
        case ID_OEM:
            newCharSet = OEM_CHARSET;
            SetCharSet(hDial);          /* Set OEM/ANSI buttons */
            break;
        case ID_UNKNOWN:
            newFamily = 0;
            //SetFamily(hDial);
            break;
        case ID_ROMAN:
            newFamily = 1;
            //SetFamily(hDial);
            break;
        case ID_SWISS:
            newFamily = 2;
            //SetFamily(hDial);
            break;
        case ID_MODERN:
            newFamily = 3;
            //SetFamily(hDial);
            break;
        case ID_SCRIPT:
            newFamily = 4;
            //SetFamily(hDial);
            break;
        case ID_DECORATIVE:
            newFamily = 5;
            //SetFamily(hDial);
            break;
        case ID_ITALIC:
            newItalic = (WORD) !newItalic;
            //CheckDlgButton(hDial, ID_ITALIC, newItalic);
            break;
        case ID_UNDERLINE:
            newUnderline = (WORD) !newUnderline;
            //CheckDlgButton(hDial, ID_UNDERLINE, newUnderline);
            break;
        case ID_STRIKEOUT:
            newStrikeOut = (WORD) !newStrikeOut;
            //CheckDlgButton(hDial, ID_STRIKEOUT, newStrikeOut);
            break;
        case ID_CHAR_SET  :
            i = GetDlgItemInt(hDial, ID_CHAR_SET, (LPBOOL)&fOk, FALSE);
            if (fOk && (i < 256))
                {
                newCharSet = (WORD) i;
                CheckDlgButton(hDial, ID_ANSI, (WORD) (i == ANSI_CHARSET));
                CheckDlgButton(hDial, ID_SYMBOL, (WORD) (i == SYMBOL_CHARSET));
                CheckDlgButton(hDial, ID_OEM, (WORD) (i == OEM_CHARSET));
                }
			break;
case ID_THIN:
            newWeight = FW_THIN;
            //SetWeight(hDial);
            break;
        case ID_EXTRALIGHT:
            newWeight = FW_EXTRALIGHT;
            //SetWeight(hDial);
            break;
        case ID_LIGHT:
            newWeight = FW_LIGHT;
            //SetWeight(hDial);
            break;
        case ID_NORMAL:
            newWeight = FW_NORMAL;
            //SetWeight(hDial);
            break;
        case ID_MEDIUM:
            newWeight = FW_MEDIUM;
            //SetWeight(hDial);
            break;
        case ID_BOLD:
            newWeight = FW_BOLD;
            //SetWeight(hDial);
            break;
        case ID_SEMIBOLD:
            newWeight = FW_SEMIBOLD;
            //SetWeight(hDial);
            break;
        case ID_EXTRABOLD:
            newWeight = FW_EXTRABOLD;
            //SetWeight(hDial);
            break;
        case ID_HEAVY:
            newWeight = FW_HEAVY;
            //SetWeight(hDial);
            break;

        case ID_FIXED:
            newFixed = 0;
            //SetFixed(hDial, newFixed);
            break;
        case ID_VARIABLE:
            newFixed = 1;
            //SetFixed(hDial, newFixed);
            break;

        case IDOK:
// Version
			ift.Header.Version = ID_FORMAT2;
// Size
			ift.Header.Size = 0; // Niet bekend???
// Copyright
			GetDlgItemText(hDial, IDC_COPYRIGHT, (char*)&ift.Header.Copyright, sizeof(ift.Header.Copyright));
// Type
			ift.Header.Type = 0;
// Points
			i = GetDlgItemInt(hDial, ID_POINTS, (LPBOOL)&fOk, FALSE);
            if (fOk)
                ift.Header.Points = (WORD) i;
            else{
                  ErrorBox(hDial, vszNomPtSizeNotOk);
                  SetFocus(GetDlgItem(hDial, ID_POINTS));
                  break;
                }
// Vertres
			i = GetDlgItemInt(hDial, ID_VERT_RES, (LPBOOL)&fOk, FALSE);
            if (fOk)
                ift.Header.VertRes = (WORD) i;
            else{
                ErrorBox(hDial, vszNomVertResNotOk);
                SetFocus(GetDlgItem(hDial, ID_VERT_RES));
                break;
                }
// Horzres
            /* nominal horizontal resolution */
            i = GetDlgItemInt(hDial, ID_HORIZ_RES, (LPBOOL)&fOk, FALSE);
            if (fOk)
                ift.Header.HorizRes = (WORD) i;
            else{
                ErrorBox(hDial, vszNomHorResNotOk);
                SetFocus(GetDlgItem(hDial, ID_HORIZ_RES));
                break;
                }
// Ascent = Baseline
            /* font ascent */
			ift.Header.Ascent = (WORD)ift.tm.tmAscent;
// Intleading
            /* font internal leading */
            i = GetDlgItemInt(hDial, ID_INT_LEADING, (LPBOOL)&fOk, FALSE);
            if (fOk)
                {
                if (i <= ift.Header.Ascent)
                    ift.Header.IntLeading = (WORD) i;
                else{
                    ErrorBox(hDial, vszIntLeadTooBig);
                    SetFocus(GetDlgItem(hDial, ID_INT_LEADING));
                    break;
                    }
                }
            else{
                ErrorBox(hDial, vszIntLeadNotOk);
                SetFocus(GetDlgItem(hDial, ID_INT_LEADING));
                break;
                }
// ExtLeading
            /* font external leading */
            i = GetDlgItemInt(hDial, ID_EXT_LEADING, (LPBOOL)&fOk, FALSE);
            if (fOk)
                ift.Header.ExtLeading = (WORD) i;
            else{
                ErrorBox(hDial, vszExtLeadNotOk);
                SetFocus(GetDlgItem(hDial, ID_EXT_LEADING));
                break;
                }
// Italic
			ift.Header.Italic = (BYTE) newItalic;
// Underline
            ift.Header.Underline = (BYTE) newUnderline;
// Strikeout
            ift.Header.StrikeOut = (BYTE) newStrikeOut;
// Weight
			ift.Header.Weight = (WORD) newWeight;
// Charset
            /* font character set */
            i = GetDlgItemInt(hDial, ID_CHAR_SET, (LPBOOL)&fOk, FALSE);
            if (fOk && i < 256)
                {
                ift.Header.CharSet = (BYTE) i;
                SetCharSet(hDial);
                }
            else{
                ErrorBox(hDial, vszCharSetOutOfBounds);
                SetFocus(GetDlgItem(hDial, ID_CHAR_SET));
                break;
                }

// Pixwidth
			if (!newFixed)
			{	ift.Header.PixWidth = (WORD)ift.tm.tmMaxCharWidth;	}
			else ift.Header.PixWidth = 0;
// Pixheight
			ift.Header.PixHeight = (WORD)ift.tm.tmHeight;

// Family
			ift.Header.Family = newFamily << 4;
			if (newFixed == 1)
				ift.Header.Family |= 1;
// AvgWidth
			ift.Header.AvgWidth = (WORD)ift.tm.tmAveCharWidth;
// MaxWidth
			ift.Header.MaxWidth = (WORD)ift.tm.tmMaxCharWidth;
// FirstChar
		/* new first char command */
            i = GetDlgItemInt(hDial, ID_FIRST_CHAR, (LPBOOL)&fOk, FALSE);
            if (fOk && (i >= ift.tm.tmFirstChar) && (i <= ift.tm.tmLastChar) ){
					ift.Header.FirstChar = (BYTE) i;
                }
            else{
                ErrorBox(hDial, vszChar1NotOk);
                SetFocus(GetDlgItem(hDial, ID_FIRST_CHAR));
                break;
                }

// LastChar
            /* new last char command */
            i = GetDlgItemInt(hDial, ID_LAST_CHAR, (LPBOOL)&fOk, FALSE);
            if (fOk && (i >= ift.Header.FirstChar) && (i <= ift.tm.tmLastChar)) {
					ift.Header.LastChar = (BYTE) i;
				}
            else{
                ErrorBox(hDial, vszLastCharNotOk);
                SetFocus(GetDlgItem(hDial, ID_LAST_CHAR));
                break;
                }

// Defaultchar (gebruikt als teken niet bestaat)
			i = GetDlgItemInt(hDial, ID_DEFAULT_CHAR, (LPBOOL)&fOk, FALSE);

            if (fOk)
                {
                if ((i >= ift.Header.FirstChar) && (i <= ift.Header.LastChar))
                    ift.Header.DefaultChar = (BYTE) i;
                else{
                    ErrorBox(hDial, vszDefCharOutsideFont);
                    SetFocus(GetDlgItem(hDial, ID_DEFAULT_CHAR));
                    break;
                    }
                }
            else{
                ErrorBox(hDial, vszDefCharNotOk);
                SetFocus(GetDlgItem(hDial, ID_DEFAULT_CHAR));
                break;
                }
// Breakchar
            /* break char number */
            i = GetDlgItemInt(hDial, ID_BREAK_CHAR, (LPBOOL)&fOk, FALSE);
            if (fOk)
                {
                if ((BYTE)i <= (ift.Header.LastChar - ift.Header.FirstChar))
                    ift.Header.BreakChar = (BYTE) i;
                else{
                    ErrorBox(hDial, vszBreakCharOutsideFont);
                    SetFocus(GetDlgItem(hDial, ID_BREAK_CHAR));
                    break;
                    }
                }
            else{
                ErrorBox(hDial, vszBreakCharNotOk);
                SetFocus(GetDlgItem(hDial, ID_BREAK_CHAR));
                break;
                }

// WidthBytes
			ift.Header.WidthBytes = 0; // Wordt later ingevuld, als charwidths gelezen zijn

// Device
			ift.Header.Device = 0L;
			ift.Header.Face = 0L;
			ift.Header.BitsPointer = 0L;
			ift.Header.BitsOffset = 0L;

// Fontname (niet in header)
            GetDlgItemText(hDial, IDC_FONTNAME, (LPSTR)ift.szFaceName, sizeof(ift.szFaceName)-1);
            if (!lstrlen((LPSTR)ift.szFaceName))
                {
                lstrcpy((LPSTR)ift.szFaceName, (LPSTR)vszUnknown);
                ErrorBox(hDial, vszUnknownFace);
                }
			
			
        case IDCANCEL:
            EndDialog(hDial, wParam != IDCANCEL);
            break;

        default:
            break;
            }
        }
    return TRUE;
}
